.NOLIST
#define equ .equ
#define EQU .equ
#define end .end
#include "ti83asm.inc"
#include "tokens.inc"
.org 9327h

 ld (OLDIY),iy			; Main program body
 set appTextSave,(iy+appflags)
 set textwrite,(iy+sgrflags)
 res textInverse,(iy+textflags)
 res indicRun,(iy+indicflags)
 res statsvalid,(iy+statflags)
 call _clrScrnFull
 call initmenu
menucont:
 call _GRBUFCPY_V
 call _getkey
 cp 4
 jr nz,notdown
 ld a,(MENUITEM)
 cp 4
 jr z,menucont
 inc a
 ld (MENUITEM),a
 dec a
 call invitem
notdown:
 cp 3
 jr nz,notup
 ld a,(MENUITEM)
 cp 1
 jr z,menucont
 dec a
 ld (MENUITEM),a
 call invitem
notup:
 cp 2
 jr nz,notleft
 ld a,(MENUITEM)
 cp 2
 jr nz,menucont
 ld a,(TIMING)
 cp 12
 jr z,menucont
 add a,2
 ld (TIMING),a
 call showdiff
notleft:
 cp 1
 jr nz,notright
 ld a,(MENUITEM)
 cp 2
 jr nz,menucont
 ld a,(TIMING)
 cp 4
 jr z,menucont
 sub 2
 ld (TIMING),a
 call showdiff
 jr menucont
notright:
 cp 5
 jp nz,menucont
 ld a,(MENUITEM)
 cp 1
 jr nz,nogame
 call game
 call initmenu
 jp menucont
nogame:
 cp 3
 jr nz,nospeed
 ld a,(BATSPD)
 xor 1
 ld (BATSPD),a
 set textInverse,(iy+textflags)
 call showspd
 jp menucont
nospeed:
 cp 4
 jr z,quittraz
 jp menucont
quittraz:
 call _clrScrnFull
 call _GRBUFCLR
 call _homeUp
 call _eraseEOL
 res appTextSave,(iy+appflags)
 res textwrite,(iy+sgrflags)
 set indicRun,(iy+indicflags)
 ret

showdiff:
 ld d,0
 ld e,a
 ld ix,DIFFLEV-4
 add ix,de
 ld l,(ix)
 ld h,(ix+1)
 ld b,(hl)
 inc hl
 ld a,13
 ld (PENROW),a
 ld a,54
 ld (PENCOL),a
 ld ix,PLOTSSCREEN+175
 push bc
 ld b,5
 ld a,255
 ld de,12
deldift:
 ld (ix),a
 ld (ix+1),a
 ld (ix+2),a
 ld (ix+3),a
 ld (ix+4),a
 add ix,de
 djnz deldift 
 pop bc
 set textInverse,(iy+textflags)
 call _vputsn
 res textInverse,(iy+textflags)
 ret

showspd:
 ld d,0
 ld e,a
 rl e
 ld ix,BATSPEED
 add ix,de
 ld l,(ix)
 ld h,(ix+1)
 ld b,(hl)
 inc hl
 ld a,19
 ld (PENROW),a
 ld a,34
 ld (PENCOL),a
 call _vputsn
 res textInverse,(iy+textflags)
 ret

initmenu:			; Draws main menu
 call _GRBUFCLR
 ld ix,MAINMENU
 call drawmenu
 ld ix,INFOS
 call drawmenu
 ld a,1
 ld (MENUITEM),a
 ld a,(TIMING)
 ld d,0
 ld e,a
 ld ix,DIFFLEV-4
 add ix,de
 ld l,(ix)
 ld h,(ix+1)
 ld b,(hl)
 inc hl
 ld a,13
 ld (PENROW),a
 ld a,54
 ld (PENCOL),a
 call _vputsn
 ld a,(BATSPD)
 call showspd
 ld hl,PLOTSSCREEN+84
 ld b,84
invit:
 ld a,(hl)
 xor 255
 ld (hl),a
 inc hl
 djnz invit
 ret

invitem:			; inverts current and next items
 sla a
 ld b,a
 sla b
 add a,b
 inc a
 ld d,0 
 ld e,a
 ld h,0
 sla e
 sla e
 ld l,e
 sla l
 rl h
 add hl,de
 ld de,PLOTSSCREEN
 add hl,de
 ld b,72
invit2:
 ld a,(hl)
 xor 255
 ld (hl),a
 inc hl
 djnz invit2
 ld de,12
 add hl,de
 ld b,72
invit3:
 ld a,(hl)
 xor 255
 ld (hl),a
 inc hl
 djnz invit3
 ret

drawmenu:			; draws one menu
 ld b,5
 ld c,(ix)
 inc ix
drwmenu:
 push bc
 ld h,(ix+1)
 ld l,(ix)
 inc ix
 inc ix
 push ix 
 ld a,0
 ld (PENCOL),a
 ld a,5
 sub b
 ld d,a
 sla d
 sla d
 sla a
 add a,d
 ld d,a
 ld a,b
 cp 5
 jr z,titlebar
 inc d
titlebar:
 ld a,d
 add a,c
 ld (PENROW),a
 ld b,(hl)
 inc hl
 call _vputsn
 pop ix
 pop bc
 djnz drwmenu
 ld h,0
 sla c
 sla c
 ld l,c
 sla l
 rl h
 add hl,bc
 ld de,PLOTSSCREEN
 add hl,de
 ld b,84
invtit:
 ld a,(hl)
 xor 255
 ld (hl),a
 inc hl
 djnz invtit
 ret

game:				; The Crying Game
 ld a,(BATSPD)
 cp 0
 jr z,notfast1
 ld a,(TIMING)
 sub 2
 ld (TIMING),a
notfast1:
 ld (OLDSP),sp
 res indicRun,(iy+indicflags)
 ld bc,LEVELS
 ld (CURLEV),bc
 ld a,1
 ld (LEVEL),a
 ld a,5
 ld (LIVES),a
 ld (SCOREINC),a
 ld a,0
 ld (SCORE),a
 ld (SCORE+1),a
 ld (SCORE+2),a
 ld (PAUSE),a
 ld (HIT),a
 ld (CHEAT),a
 ld de,$3000
 ld (BX),de
 ld a,d
 ld (OBX),a
 ld de,$2A00
 ld (BY),de
 ld a,d
 ld (OBY),a
 ld (BATX),a
 ld de,$0098
 ld (BXI),de
 ld de,$FF00
 ld (BYI),de
 call _GRBUFCLR
 ld hl,HUD
 ld de,PLOTSSCREEN
 ld bc,60
 ldir
 ld ix,PLOTSSCREEN+72
 ld b,12
horz:
 ld (ix),255
 inc ix
 djnz horz
 ld a,42
 ld (BATX),a
 ld c,a
 di
 call drawbat
 call drawwater
 ei
 call drawlevel
 ld iy,(OLDIY)
 call _GRBUFCPY_V
wait:
 call drawball
 di
 call drawbat
 call drawwater
 call updatehud
 ei
 ld iy,(OLDIY)
 call _GRBUFCPY_V
 call _GetKy
 ld a,(OP2+2)
 cp 0
 jp nz,movebat
 ld a,(TIMING)
delloop:
 halt
 dec a
 jr nz,delloop
 ld hl,(BX)
 ld de,(BXI)
 add hl,de
 ld (BX),hl
 ld a,h
 cp 93
 jr z,negx
 cp 0
 jr z,negx
 cp 255
 jr nz,okx
 ld bc,0
 ld (BX),bc
negx:
 ld a,d
 xor -1
 ld d,a
 ld a,e
 xor -1
 ld e,a
 inc de
 ld (BXI),de
okx:
 ld hl,(BY)
 ld de,(BYI)
 add hl,de
 ld (BY),hl
 ld a,h
 cp 52
 jr z,checkbat
 cp 0
 jp nz,wait
 jr negy
checkbat:
 ld a,(BX+1)
 inc a
 ld hl,BATX
 sub (hl)
 jp c,death
 cp 8
 jp nc,death
 ld hl,(BXI)
 sla a
 sla a
 sla a
 sla a
 ld b,0
 ld c,a
 add hl,bc
 ld bc,-64
 add hl,bc
 ld a,h
 cp 0
 jr z,okxinc
 cp -1
 jr z,okxinc
 cp 1
 jr z,noxinc
 cp l
 jr z,noxinc
 ld hl,$ff08
 jr okxinc
noxinc:
 ld hl,$00f7
okxinc:
 ld (BXI),hl
negy:
 ld a,d
 xor -1
 ld d,a
 ld a,e
 xor -1
 ld e,a
 inc de
 ld (BYI),de
 jp wait
movebat:
 ld bc,(BATX)
 cp $24
 jr nz,noleft
 ld a,0
 ld (CHEAT),a
 ld a,(PAUSE)
 cp 1
 jp z,wait
 ld a,0
 cp c
 jp z,wait
 dec c
 ld a,(BATSPD)
 cp 0
 jr z,okshl
 dec c
okshl:
 ld a,c
 ld (BATX),a
 jp wait
noleft:
 cp $26 
 jr nz,noright
 ld a,0
 ld (CHEAT),a
 ld a,(PAUSE)
 cp 1
 jp z,wait
 ld a,c
 cp 88
 jp nc,wait
 inc c
 ld a,(BATSPD)
 cp 0
 jr z,okshr
 inc c
okshr:
 ld a,c
 ld (BATX),a
 jp wait
noright:
 cp $23
 jp nz,nopause
 ld a,0
 ld (CHEAT),a
 ld a,(PAUSE)
 xor 1
 ld (PAUSE),a
 jp z,unpause
 ld ix,PAUSED
 ld iy,PLOTSSCREEN+664
 ld b,5
paline:
 ld a,(ix)
 ld (iy),a
 ld a,(ix+1)
 ld (iy+1),a
 ld a,(ix+2)
 ld (iy+2),a
 ld a,(ix+3)
 ld (iy+3),a
 ld de,12
 add iy,de
 ld de,4
 add ix,de
 djnz paline
 ld iy,(OLDIY)
 ld de,(BXI)
 ld (OXI),de
 ld de,(BYI)
 ld (OYI),de
 ld de,0
 ld (BXI),de
 ld (BYI),de
 call waitrel
 res indicRun,(iy+indicflags)
 jp wait
unpause:
 ld de,(OXI)
 ld (BXI),de
 ld de,(OYI)
 ld (BYI),de
 call waitrel
 ld hl,PLOTSSCREEN+660
 ld a,0
 ld b,60
delps:
 ld (hl),a
 inc hl
 djnz delps
 jp wait
nopause:
 cp $21
 jr z,gameover
 ld d,0
 ld ix,CHEAT
 ld e,(ix)
 ld ix,CHNUM
 add ix,de
 cp (ix)
 jr nz,nocheat
 ld a,(PAUSE)
 cp 0
 jr nz,nocheat
 ld a,(CHEAT)
 inc a
 ld (CHEAT),a
 cp 4
 jp nz,wait 
 ld a,1
 ld (LEVELOKAY),a
 ld a,5
 ld (SCOREINC),a
 ld a,0
 ld (SCORE),a
 ld (SCORE+1),a
 ld (SCORE+2),a
 ld (HIT),a
nocheat:
 ld a,0
 ld (CHEAT),a
 jp wait
gameover:
 ld hl,SUCKLINGMASK
 ld ix,PLOTSSCREEN+363
 ld de,6
 ld b,7
gomlin:
 ld c,6
gomdot:
 ld a,(hl)
 inc hl
 and (ix)
 ld (ix),a
 inc ix
 dec c
 jr nz,gomdot
 add ix,de
 djnz gomlin
 ld hl,SUCKLING
 ld ix,PLOTSSCREEN+375
 ld de,6
 ld b,5
golin:
 ld c,6
godot:
 ld a,(hl)
 inc hl
 or (ix)
 ld (ix),a
 inc ix
 dec c
 jr nz,godot
 add ix,de
 djnz golin
 ld iy,(OLDIY)
 call _GRBUFCPY_V
 call wenter
 ld iy,(OLDIY)
 ld a,(BATSPD)
 cp 0
 jr z,notfast2
 ld a,(TIMING)
 add a,2
 ld (TIMING),a
notfast2:
 ret

winner:				; All levels finished
 ; some awardish thing should be included here...
 jr gameover

wenter:
 call _getkey
 cp 5
 jr nz,wenter
waitrel:
 call _GetKy
 ld a,(OP2+2)
 cp 0
 jp nz,waitrel
 ret

death:				; Death penalty...
 ld a,(LIVES)
 dec a
 jr z,gameover
 ld (LIVES),a
 call drawball
 call drawbat
 call drawwater
 ld de,$3000
 ld (BX),de
 ld de,$2A00
 ld (BY),de
 ld de,$0098
 ld (BXI),de
 ld de,$FF00
 ld (BYI),de
 ld a,42
 ld (BATX),a
 ld a,0
 ld (HIT),a
 ld a,$05
 ld (SCOREINC),a
 ld hl,LOST
 ld de,PLOTSSCREEN+660
 ld bc,60
 ldir
 ld iy,(OLDIY)
 call _GRBUFCPY_V
 call wenter
 ld hl,PLOTSSCREEN+660
 ld a,0
 ld b,60
dellost:
 ld (hl),a
 inc hl
 djnz dellost
 res indicRun,(iy+indicflags)
 jp wait

incscore:			; Update score
 push bc
 push ix
 ld ix,SCORE
 ld a,(SCOREINC)
 ld b,(ix+2)
 add a,b
 daa
 ld (ix+2),a
 ld a,0
 adc a,0
 ld b,(ix+1)
 add a,b
 daa
 ld (ix+1),a
 push af
 xor b
 and $20
 jr z,nolifeinc1
 ld a,(LIVES)
 inc a
 ld (LIVES),a
nolifeinc1:
 pop af 
 ld a,0
 adc a,0
 ld b,(ix)
 add a,b
 daa
 ld (ix),a
 push af
 xor b
 and $01
 jr z,nolifeinc2
 ld a,(LIVES)
 inc a
 ld (LIVES),a
nolifeinc2:
 pop af 
 ld a,(BLOCKS)
 dec a
 ld (BLOCKS),a
 jr nz,noendlev
 ld a,1
 ld (LEVELOKAY),a
noendlev:
 ld a,(HIT)
 cp 100
 jr nc,endhit
 inc a
 ld (HIT),a
 cp 10
 jr nz,not10
 ld a,$10
 ld (SCOREINC),a
 jr endhit
not10:
 cp 20
 jr nz,not20
 ld a,$15
 ld (SCOREINC),a
 jr endhit
not20:
 cp 30
 jr nz,not30
 ld a,$20
 ld (SCOREINC),a
 jr endhit
not30:
 cp 40
 jr nz,not40
 ld a,$25
 ld (SCOREINC),a
 jr endhit
not40:
 cp 50
 jr nz,not50
 ld a,$30
 ld (SCOREINC),a
 jr endhit
not50:
 cp 60
 jr nz,not60
 ld a,$35
 ld (SCOREINC),a
 jr endhit
not60:
 cp 70
 jr nz,not70
 ld a,$40
 ld (SCOREINC),a
 jr endhit
not70:
 cp 80
 jr nz,not80
 ld a,$45
 ld (SCOREINC),a
 jr endhit
not80:
 cp 90
 jr nz,endhit
 ld a,$50
 ld (SCOREINC),a
endhit:
 pop ix
 pop bc
 ret

drawball:			; Drawing ball v2 ******************
 ld ix,PLOTSSCREEN+732
 ld a,0
 ld b,36
delbot:
 ld (ix),a
 inc ix
 djnz delbot
 ld ix,PLOTSSCREEN+96
 ld a,(OBY)
 ld d,0
 ld e,a
 sla e
 sla e
 add ix,de
 sla e
 rl d
 add ix,de
 ld a,(OBX)
 ld d,0
 ld e,a
 srl e
 srl e
 srl e
 add ix,de
 ld bc,$e000
 ld de,$bfff
 and 7
 jr z,noshe
shifte:
 srl b
 rr c
 sra d
 rr e
 dec a
 jr nz,shifte
noshe:
 ld a,b
 xor 255
 ld b,a
 ld a,c
 xor 255
 ld c,a
 ld a,(ix-12)
 and d
 ld (ix-12),a
 ld a,(ix-11)
 and e
 ld (ix-11),a
 ld a,(ix)
 and b
 ld (ix),a
 ld a,(ix+1)
 and c
 ld (ix+1),a
 ld a,(ix+12)
 and d
 ld (ix+12),a
 ld a,(ix+13)
 and e
 ld (ix+13),a
 ld ix,PLOTSSCREEN+96
 ld a,(BY+1)
 ld (OBY),a
 ld d,0
 ld e,a
 sla e
 sla e
 add ix,de
 sla e
 rl d
 add ix,de
 ld a,(BX+1)
 ld (OBX),a
 ld d,0
 ld e,a
 srl e
 srl e
 srl e
 add ix,de
 ld bc,$e000
 ld de,$4000
 and 7
 jr z,noshb
shiftb:
 srl b
 rr c
 srl d
 rr e
 dec a
 jr nz,shiftb
noshb:
 ld a,d
 cp 0
 jp z,drwe				; bounce a
 ld a,(ix+1)
 and c
 jr z,nocr1
 push de
 ld iy,PLOTSSCREEN+85
 ld a,(BY+1)
 inc a
 and %11111100
 ld d,0
 ld e,a
 sla e
 sla e
 add iy,de
 sla e
 rl d
 add iy,de
 ld a,(BX+1)
 ld d,0
 ld e,a
 srl e
 srl e
 srl e
 add iy,de
 ld a,0
 ld (iy),a
 ld (iy+12),a
 ld (iy+24),a
 ld (iy+36),a
 ld hl,(BXI)
 ld a,h
 xor -1
 ld h,a
 ld a,l
 xor -1
 ld l,a
 inc hl
 ld (BXI),hl
 call incscore
 pop de
nocr1:
 ld a,(ix+1)
 or c
 ld (ix+1),a

 ld a,(ix-12)
 and d
 jr z,nocu1
 push de
 ld iy,PLOTSSCREEN+84
 ld a,(BY+1)
 dec a
 and %11111100
 ld d,0
 ld e,a
 sla e
 sla e
 add iy,de
 sla e
 rl d
 add iy,de
 ld a,(BX+1)
 ld d,0
 ld e,a
 srl e
 srl e
 srl e
 add iy,de
 ld a,0
 ld (iy),a
 ld (iy+12),a
 ld (iy+24),a
 ld (iy+36),a
 ld hl,(BYI)
 ld a,h
 xor -1
 ld h,a
 ld a,l
 xor -1
 ld l,a
 inc hl
 ld (BYI),hl
 call incscore
 pop de
nocu1:
 ld a,(ix-12)
 or d
 ld (ix-12),a

 ld a,(ix+12)
 and d
 jr z,nocd1
 push de
 ld iy,PLOTSSCREEN+132
 ld a,(BY+1)
 and %11111100
 ld d,0
 ld e,a
 sla e
 sla e
 add iy,de
 sla e
 rl d
 add iy,de
 ld a,(BX+1)
 ld d,0
 ld e,a
 srl e
 srl e
 srl e
 add iy,de
 ld a,0
 ld (iy),a
 ld (iy+12),a
 ld (iy+24),a
 ld (iy+36),a
 ld hl,(BYI)
 ld a,h
 xor -1
 ld h,a
 ld a,l
 xor -1
 ld l,a
 inc hl
 ld (BYI),hl
 call incscore
 pop de
nocd1:
 ld a,(ix+12)
 or d
 ld (ix+12),a

 ld a,(ix)
 or b
 ld (ix),a
 jp endball
drwe:					; bounce b
 ld a,(ix)
 and b
 jr z,nocl2
 push de
 ld iy,PLOTSSCREEN+84
 ld a,(BY+1)
 inc a
 and %11111100
 ld d,0
 ld e,a
 sla e
 sla e
 add iy,de
 sla e
 rl d
 add iy,de
 ld a,(BX+1)
 ld d,0
 ld e,a
 srl e
 srl e
 srl e
 add iy,de
 ld a,0
 ld (iy),a
 ld (iy+12),a
 ld (iy+24),a
 ld (iy+36),a
 ld hl,(BXI)
 ld a,h
 xor -1
 ld h,a
 ld a,l
 xor -1
 ld l,a
 inc hl
 ld (BXI),hl
 call incscore
 pop de
nocl2:
 ld a,(ix)
 or b
 ld (ix),a

 ld a,(ix-11)
 and e
 jr z,nocu2
 push de
 ld iy,PLOTSSCREEN+85
 ld a,(BY+1)
 dec a
 and %11111100
 ld d,0
 ld e,a
 sla e
 sla e
 add iy,de
 sla e
 rl d
 add iy,de
 ld a,(BX+1)
 ld d,0
 ld e,a
 srl e
 srl e
 srl e
 add iy,de
 ld a,0
 ld (iy),a
 ld (iy+12),a
 ld (iy+24),a
 ld (iy+36),a
 ld hl,(BYI)
 ld a,h
 xor -1
 ld h,a
 ld a,l
 xor -1
 ld l,a
 inc hl
 ld (BYI),hl
 call incscore
 pop de
nocu2:
 ld a,(ix-11)
 or e
 ld (ix-11),a

 ld a,(ix+13)
 and e
 jr z,nocd2
 push de
 ld iy,PLOTSSCREEN+133
 ld a,(BY+1)
 and %11111100
 ld d,0
 ld e,a
 sla e
 sla e
 add iy,de
 sla e
 rl d
 add iy,de
 ld a,(BX+1)
 ld d,0
 ld e,a
 srl e
 srl e
 srl e
 add iy,de
 ld a,0
 ld (iy),a
 ld (iy+12),a
 ld (iy+24),a
 ld (iy+36),a
 ld hl,(BYI)
 ld a,h
 xor -1
 ld h,a
 ld a,l
 xor -1
 ld l,a
 inc hl
 ld (BYI),hl
 call incscore
 pop de
nocd2:
 ld a,(ix+13)
 or e
 ld (ix+13),a

 ld a,(ix+1)
 or c
 ld (ix+1),a
endball:
 ld a,(LEVELOKAY)
 cp 0
 jr z,endbdrw

 ld de,$3000
 ld (BX),de
 ld de,$2A00
 ld (BY),de
 ld de,$0098
 ld (BXI),de
 ld de,$FF00
 ld (BYI),de
 ld a,42
 ld (BATX),a
 ld (OBX),a
 ld a,48
 ld (OBY),a
 ld hl,NEWLEV
 ld de,PLOTSSCREEN+372
 ld bc,60
 ldir
 ld iy,(OLDIY)
 call _GRBUFCPY_V
 call wenter
 call drawlevel
 ld a,(LEVEL)
 inc a
 ld (LEVEL),a
 res indicRun,(iy+indicflags)
endbdrw:
 ret

drawlevel:			; Drawing a set of blocks to VS (found at CURLEV)
 ld hl,(CURLEV)
 ld de,ENDPRG
 ld a,l
 cp e
 jr nz,noteq
 ld a,h
 cp d
 jr nz,noteq
 ld sp,(OLDSP)
 jp winner
noteq:
 ld ix,STATVARS
 ld d,0
 ld a,0
 ld b,18
convlev:
 ld e,(hl)
 inc hl
 ld c,8
convbit:
 sla e
 jr nc,notset
 add a,d
 ld (ix),a
 inc ix
 sub d
notset:
 add a,16
 cp 192
 jr nz,lineok
 inc d
 ld a,0
lineok:
 dec c
 jr nz,convbit
 djnz convlev
 ld (ix),255
 ld hl,(CURLEV)
 ld de,18
 add hl,de
 ld (CURLEV),hl
 ld hl,PLOTSSCREEN+84
 ld a,0
 ld b,172
delnl1:
 ld (hl),a
 inc hl
 djnz delnl1
delnl2:
 ld (hl),a
 inc hl
 djnz delnl2
delnl3:
 ld (hl),a
 inc hl
 djnz delnl3
 ld (BLOCKS),a
 ld (LEVELOKAY),a
 ld hl,STATVARS
drawlev:
 ld a,(hl)
 cp 255
 jr z,endlev
 ld b,a
 and $0f
 ld c,a
 srl b
 srl b
 srl b
 srl b
 call drawblock
 ld a,(BLOCKS)
 inc a
 ld (BLOCKS),a
 inc hl
 jr drawlev
endlev:
 ret

drawblock:			; Drawing a single block to VS - b=column, c=row
 ld ix,PLOTSSCREEN+38
 ld d,0
 ld e,b
 add ix,de
 ld e,c
 sll e
 sll e
 sll e
 rl d
 sll e
 rl d
 add ix,de
 sll e
 rl d
 add ix,de
 ld a,%11111111
 ld (ix),a
 ld (ix+36),a
 ld a,%10101011
 ld (ix+12),a
 ld a,%11010101
 ld (ix+24),a
 ret

drawbat:			; Drawing bat to VS
 ld a,(BATX)
 ld iy,PLOTSSCREEN+732
 ld d,0
 ld e,a
 srl e
 srl e
 srl e
 add iy,de
 ld (BATADDR),iy
 and 7
 ld b,a
 ld ix,BAT
 ld a,(ix)
 ld d,a
 ld e,0
 ld a,(ix+1)
 ld (iy+12),a
 ld a,(ix+2)
 ld (iy+24),a
 ld a,0
 cp b
 jr z,noshf
shift:
 srl d
 rr e
 srl (iy+12)
 rr (iy+13)
 srl (iy+24)
 rr (iy+25)
 dec b
 jr nz,shift
noshf:
 ld a,(iy)
 or d
 ld (iy),a
 ld a,(iy+1)
 or e
 ld (iy+1),a
 ret

drawwater:			; Drawing water to VS
 ld ix,PLOTSSCREEN+744
 ld iy,BX
 ld hl,WATER
 ld b,12
wloop:
 ld c,(hl)
 ld a,(ix)
 or c
 ld (ix),a
 ld a,c
 xor 255
 ld c,a
 ld a,(ix+12)
 or c
 ld (ix+12),a
 ld a,c
 xor (iy)
 ld (hl),a
 inc hl
 inc ix
 djnz wloop
 ret

updatehud:			; Updating numbers on the display
 ld a,(LIVES)
 ld b,0
divliv:
 sub 10
 jr c,dle1
 jr z,dle2
 inc b
 jr divliv
dle1:
 add a,10
 dec b
dle2:
 inc b
 ld ix,PLOTSSCREEN+11
 ld hl,NUM
 ld d,0
 ld e,a
 add hl,de
 sla e
 sla e
 add hl,de
 ld de,12
 ld c,5
liv1:
 ld a,(hl)
 inc hl
 srl a
 srl a
 srl a
 srl a
 srl a
 ld (ix),a
 add ix,de
 dec c
 jr nz,liv1
 ld ix,PLOTSSCREEN+11
 ld hl,NUM
 ld d,0
 ld e,b
 add hl,de
 sla e
 sla e
 add hl,de
 ld de,12
 ld c,5
liv2:
 ld a,(hl)
 inc hl
 srl a
 or (ix)
 ld (ix),a
 add ix,de
 dec c
 jr nz,liv2
 ld a,(LEVEL)
 ld b,0
divlev:
 sub 10
 jr c,dlve1
 jr z,dlve2
 inc b
 jr divlev
dlve1:
 add a,10
 dec b
dlve2:
 inc b
 ld ix,PLOTSSCREEN+8
 ld hl,NUM
 ld d,0
 ld e,a
 add hl,de
 sla e
 sla e
 add hl,de
 ld de,12
 ld c,5
 push bc
lev1:
 ld a,(ix)
 and $0f
 ld b,(hl)
 inc hl
 srl b
 or b
 ld (ix),a
 add ix,de
 dec c
 jr nz,lev1
 pop bc
 ld ix,PLOTSSCREEN+7
 ld hl,NUM
 ld d,0
 ld e,b
 add hl,de
 sla e
 sla e
 add hl,de
 ld de,12
lev2:
 ld a,(ix)
 and $f0
 ld b,(hl)
 inc hl
 srl b
 srl b
 srl b
 srl b
 srl b
 or b
 ld (ix),a
 add ix,de
 dec c
 jr nz,lev2
 ld a,(SCORE+2)
 ld b,a
 and 15
 srl b
 srl b
 srl b
 srl b
 ld ix,PLOTSSCREEN+4
 ld hl,NUM
 ld d,0
 ld e,a
 add hl,de
 sla e
 sla e
 add hl,de
 ld de,12
 ld c,5
sca1:
 ld a,(hl)
 inc hl
 srl a
 srl a
 srl a
 srl a
 ld (ix),a
 add ix,de
 dec c
 jr nz,sca1
 ld ix,PLOTSSCREEN+4
 ld hl,NUM
 ld d,0
 ld e,b
 add hl,de
 sla e
 sla e
 add hl,de
 ld de,12
 ld c,5
sca2:
 ld a,(hl)
 inc hl
 or (ix)
 ld (ix),a
 add ix,de
 dec c
 jr nz,sca2
 ld a,(SCORE+1)
 ld b,a
 and 15
 srl b
 srl b
 srl b
 srl b
 ld ix,PLOTSSCREEN+3
 ld hl,NUM
 ld d,0
 ld e,a
 add hl,de
 sla e
 sla e
 add hl,de
 ld de,12
 ld c,5
scb1:
 ld a,(hl)
 inc hl
 srl a
 srl a
 srl a
 srl a
 ld (ix),a
 add ix,de
 dec c
 jr nz,scb1
 ld ix,PLOTSSCREEN+3
 ld hl,NUM
 ld d,0
 ld e,b
 add hl,de
 sla e
 sla e
 add hl,de
 ld de,12
 ld c,5
scb2:
 ld a,(hl)
 inc hl
 or (ix)
 ld (ix),a
 add ix,de
 dec c
 jr nz,scb2
 ld a,(SCORE)
 ld ix,PLOTSSCREEN+2
 ld hl,NUM
 ld d,0
 ld e,a
 add hl,de
 sla e
 sla e
 add hl,de
 ld de,12
 ld c,5
scc1:
 ld a,(ix)
 and $f0
 ld b,(hl)
 inc hl
 srl b
 srl b
 srl b
 srl b
 or b
 ld (ix),a
 add ix,de
 dec c
 jr nz,scc1
 ret

OBX:
 .byte 42
OBY:
 .byte 48
BX:
 .byte 0,42
BY:
 .byte 0,48
BXI:
 .byte 152,0
BYI:
 .byte 0,-1
LEVELOKAY
 .byte 0

OXI:
 .word 0
OYI:
 .word 0
PAUSE:
 .byte 0

BATX:
 .byte 0

OLDIY:
 .word 0
OLDSP:
 .word 0

BAT:
 .byte %01111110
 .byte %11100111
 .byte %11000011
BATADDR:
 .word 0

CHEAT:
 .byte 0

CHNUM:
 .byte $92,$74,$73,$93			; Cheat code: "1982" to be typed during gameplay

WATER:
 .byte "aO8[$g+q.i"

MAINMENU:
 .byte 0
 .word MT,M1,M2,M3,M4

MT: .byte 21, "Traz by Patai Gergely"
M1: .byte 10, "Start game"
M2: .byte 17, "Difficulty level:"
M3: .byte 10, "Bat speed:"
M4: .byte  4, "Quit"

INFOS:
 .byte 36
 .word IT,I1,I2,I3,I4

IT: .byte  9, "Controls:"
I1: .byte 14, "<-> - move bat"
I2: .byte 15, "2nd - quit game"
I3: .byte 11, "del - pause"
I4: .byte  1, " "

DIFFLEV:
 .word D5,D4,D3,D2,D1

D1: .byte 7, "EASIEST"
D2: .byte 4, "EASY"
D3: .byte 6, "MEDIUM"
D4: .byte 4, "HARD"
D5: .byte 7, "HARDEST"

BATSPD:
 .byte 0

BATSPEED:
 .word NORM, DOUB

NORM: .byte 6, "NORMAL"
DOUB: .byte 6, "DOUBLE"

MENUITEM:
 .byte 1

TIMING:
 .byte 8

LIVES:
 .byte 5
LEVEL:
 .byte 1
SCORE:
 .byte $00,$00,$00
SCOREINC:
 .byte $05
BLOCKS:
 .byte 0
HIT:
 .byte 0

HUD:
 .byte %01100000,%00000000,%00001110,%11101110,%11101110,%01000000,%00000000,%01000111,%01110010,%00100000,%00000000,%01110111
 .byte %10000100,%10011001,%00001010,%10101010,%10101010,%01000010,%01010010,%01000101,%01010010,%00001010,%01001100,%01010101
 .byte %01001001,%01010011,%10101010,%10101010,%10101010,%01000111,%01010111,%01010101,%01010010,%00101010,%11101001,%01010101
 .byte %00101001,%01010010,%00001010,%10101010,%10101010,%01000100,%01010100,%01000101,%01010010,%00101010,%10000100,%01010101
 .byte %11000100,%10010001,%10101110,%11101110,%11101110,%01110011,%00100011,%01010111,%01110011,%10100100,%01101101,%01110111

LOST:
 .byte %00001010,%00000000,%00100000,%00000000,%00000010,%10010000,%00000000,%11000000,%00000000,%00011100,%00000000,%00000000
 .byte %00001010,%01001010,%00100100,%01010000,%01100010,%00100010,%00000000,%10101100,%10001001,%00010001,%10010001,%00110000
 .byte %00000100,%10101010,%00101010,%10011000,%10100010,%10110111,%00111100,%11001001,%11010010,%00011001,%01011011,%10100000
 .byte %00000100,%10101010,%00101010,%01010000,%10100010,%10100100,%00000000,%10001001,%00001001,%00010001,%01010010,%00100000
 .byte %00000100,%01000110,%00100100,%10001000,%01100010,%10100011,%00000000,%10001000,%11010010,%00011101,%01001001,%10100000

NEWLEV:
 .byte %00001000,%00000000,%00001000,%00001000,%00000000,%00000001,%00000000,%11000000,%00000000,%00011100,%00000000,%00000000
 .byte %00001000,%01001010,%01001000,%01101001,%00011011,%00100011,%00000000,%10101100,%10001001,%00010001,%10010001,%00110000
 .byte %00001000,%11101010,%11101000,%10001011,%10101010,%01110101,%00111100,%11001001,%11010010,%00011001,%01011011,%10100000
 .byte %00001000,%10001010,%10001000,%10001010,%00101010,%01000101,%00000000,%10001001,%00001001,%00010001,%01010010,%00100000
 .byte %00001110,%01100100,%01101000,%01101001,%10011010,%00110011,%00000000,%10001000,%11010010,%00011101,%01001001,%10100000

PAUSED:
 .byte %01110001,%10010010,%01110111,%10111000
 .byte %01001010,%01010010,%10000100,%00100100
 .byte %01110011,%11010010,%01100111,%00100100
 .byte %01000010,%01010010,%00010100,%00100100
 .byte %01000010,%01001100,%11100111,%10111000

SUCKLING:
 .byte %00011100,%11001000,%10111100,%00011001,%00010111,%10111000
 .byte %00100001,%00101101,%10100000,%00100101,%00010100,%00100100
 .byte %00101101,%11101010,%10111000,%00100100,%10100111,%00111000
 .byte %00100101,%00101000,%10100000,%00100100,%10100100,%00100100
 .byte %00011101,%00101000,%10111100,%00011000,%01000111,%10100100

SUCKLINGMASK:
 .byte %11100011,%00110111,%01000011,%11100110,%11101000,%01000111
 .byte %11000000,%00000010,%00000001,%11000000,%01000000,%00000011
 .byte %10000000,%00000000,%00000011,%10000000,%01000000,%00000001
 .byte %10000000,%00000000,%00000011,%10000000,%00000000,%00000011
 .byte %10000000,%00000000,%00000011,%10000000,%00000000,%00000001
 .byte %11000000,%00000010,%00000001,%11000011,%00010000,%00000001
 .byte %11100010,%11010111,%01000011,%11100111,%10111000,%01011011

NUM:
 .byte %11100000
 .byte %10100000
 .byte %10100000
 .byte %10100000
 .byte %11100000

 .byte %00100000
 .byte %00100000
 .byte %00100000
 .byte %00100000
 .byte %00100000

 .byte %11100000
 .byte %00100000
 .byte %11100000
 .byte %10000000
 .byte %11100000

 .byte %11100000
 .byte %00100000
 .byte %11100000
 .byte %00100000
 .byte %11100000

 .byte %10100000
 .byte %10100000
 .byte %11100000
 .byte %00100000
 .byte %00100000

 .byte %11100000
 .byte %10000000
 .byte %11100000
 .byte %00100000
 .byte %11100000

 .byte %11100000
 .byte %10000000
 .byte %11100000
 .byte %10100000
 .byte %11100000

 .byte %11100000
 .byte %00100000
 .byte %00100000
 .byte %00100000
 .byte %00100000

 .byte %11100000
 .byte %10100000
 .byte %11100000
 .byte %10100000
 .byte %11100000

 .byte %11100000
 .byte %10100000
 .byte %11100000
 .byte %00100000
 .byte %11100000

CURLEV:
 .word LEVELS

LEVELS:

L010:
 .byte %00000000,%00000000,%00000000
 .byte %00000000,%00000000,%00000000
 .byte %11111111,%11111111,%11111111
 .byte %11111111,%11111111,%11111111
 .byte %00000000,%00000000,%00000000
 .byte %00000000,%00000000,%00000000

L020:
 .byte %11110000,%11111111,%00001111
 .byte %11110000,%11111111,%00001111
 .byte %00000000,%00000000,%00000000
 .byte %00000000,%00000000,%00000000
 .byte %11110000,%11111111,%00001111
 .byte %11110000,%11111111,%00001111

L025:
 .byte %11111111,%11111111,%11111111
 .byte %10000000,%00011000,%00000001
 .byte %10111111,%11011011,%11111101
 .byte %10000000,%00011000,%00000001
 .byte %11111001,%11111111,%10011111
 .byte %00000000,%00000000,%00000000

L030:
 .byte %11000000,%00111100,%00000011
 .byte %11000000,%00111101,%11111011
 .byte %11011111,%10111101,%11111011
 .byte %00011111,%10000001,%11111000
 .byte %00011111,%10000000,%00000000
 .byte %00000000,%00000000,%00000000

L035:
 .byte %11111001,%11111000,%10010001
 .byte %10101001,%01011110,%10010111
 .byte %10001001,%00011111,%10011111
 .byte %11111001,%11111000,%10010001
 .byte %11101001,%01111010,%10010101
 .byte %10001001,%00011111,%10011111

L040:
 .byte %11110000,%11111110,%00000111
 .byte %11000000,%00111000,%01100001
 .byte %00001111,%00000001,%11111000
 .byte %00111111,%11000111,%11111110
 .byte %11111111,%11110000,%00000000
 .byte %00000000,%00000000,%00000000

L050:
 .byte %00000000,%00001111,%11111111
 .byte %00000000,%00001110,%10111011
 .byte %01001010,%10010100,%10111011
 .byte %01001010,%10010100,%10111011
 .byte %00000000,%00001111,%11111111
 .byte %00000000,%00000000,%00000000

L060:
 .byte %11000000,%00111110,%00000111
 .byte %11110000,%11111111,%10011111
 .byte %11111111,%11110111,%11111110
 .byte %00111111,%11000001,%11111000
 .byte %00001111,%00000000,%01100000
 .byte %00000000,%00000000,%00000000

L070:
 .byte %00000000,%00001111,%11111111
 .byte %00000000,%00001111,%11100111
 .byte %00000000,%00001111,%10011111
 .byte %00000000,%00001001,%11111111
 .byte %00000000,%00001111,%11110011
 .byte %00000000,%00001111,%00111111

L080:
 .byte %11011111,%11111110,%11011111
 .byte %11110010,%11101110,%11110101
 .byte %01011111,%10111010,%01111101
 .byte %11111011,%10111111,%01110111
 .byte %00000000,%00000000,%00000000
 .byte %00000000,%00000000,%00000000

L090:
 .byte %00000000,%00000000,%00000000
 .byte %00011111,%10000011,%11111100
 .byte %01111111,%11101111,%00001111
 .byte %11100000,%01111100,%00000011
 .byte %11001111,%00111001,%11111001
 .byte %00110000,%11000111,%10011110

L100:
 .byte %00100010,%10001000,%10000010
 .byte %01001000,%01000001,%00001000
 .byte %00010010,%00100100,%00010001
 .byte %01000000,%01001000,%10010000
 .byte %00010001,%00010010,%00101001
 .byte %01000100,%10001001,%00100010

L110:
 .byte %11101111,%11111110,%10000010
 .byte %11101011,%10101110,%10111010
 .byte %00001011,%10111111,%10000000
 .byte %00001111,%01111110,%01010111
 .byte %11110101,%01111111,%01010000
 .byte %11110101,%11110000,%00000000

ENDPRG:

.end
END